/*-
 * Copyright (c) 2000 Roman V. Palagin
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pmap.h,v 1.1.1.1 2000/12/30 14:26:41 romanp Exp $
 */

#define MAXNAMLEN	255

struct	l_nch {
    u_long	vp;			/* vnode */
    u_long	dvp;			/* parent vnode */
    u_long  	id, did;		/* vnode id, parent vnode id */
    u_long 	flag, dflag;		/* vnode flags, parent vnode flags */
    enum vtype 	vp_type, dvp_type;	/* vnode type, parent vnode type */
    char 	name[MAXNAMLEN+1];	/* FS object name */
    struct l_nch *pa;			/* address of parent vnode l_nch */
};

struct l_nchash {
    u_long 		n_idx;
    struct l_nch 	*l_nch;
};

int namec_load(void);
char *namec_lookup(u_long, u_long);

/* kernel-related functions */
int k_open(void);
int k_read(u_long, void *, size_t);
int k_close(void);
struct kinfo_proc *k_getallprocs(int *);
struct nlist;
int k_nlist(struct nlist*);
