/* $Header: /a/ncvs/romanp/pmap/test/malloc.c,v 1.2 2001/01/09 10:23:27 romanp Exp $ */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <err.h>
#include <string.h>

int main(int argc, char **argv)
{
    int c, touch_region = 0;
    size_t size = -1;
    void *addr;

    while((c = getopt(argc, argv, "t:s:")) != -1)
    {
	switch(c) {
	case 's': /* size */
	    size = atoi(optarg);
	    break;
	case 't':
	    if(optarg[0] == 'w') touch_region = 2;
	    else touch_region = 1;
	    break;
	}
    }
    if(size == -1) 
	errx(1,"usage: malloc -s size [-t r|w]");
    printf("my pid = %d\n", getpid());
    printf("ready to mallocing memory, press <Return>\n");
    getchar();
    addr = malloc(size);
    if(addr == NULL) 
	err(1,"malloc");
    printf("%d bytes malloced. Press <Return>\n", size);
    getchar();
    if(touch_region) {
	switch (touch_region) {
	case 1:
	    memcmp(addr, addr, size);
	    break;
	case 2:
	    bzero(addr, size);
	    break;
	}
	printf("malloced region %s. Press <Return>\n", 
	       touch_region == 2 ? "zeroed" : "touched");
	getchar();
    }
    free(addr);

    return 0;
}
