/* $Header: /a/ncvs/romanp/pmap/test/mmap.c,v 1.2 2001/01/09 10:23:27 romanp Exp $ */

#include <sys/types.h>
#include <sys/mman.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <err.h>
#include <string.h>

int main(int argc, char **argv)
{
    int fd = -1, flags, prot = PROT_READ;
    int private = 0, allow_write = 0, touch_region = 0;
    int c;
    off_t off = 0;
    caddr_t addr;
    size_t len = -1;
    char *fname = NULL;

    while((c = getopt(argc, argv, "t:l:o:f:pw")) != -1)
    {
	switch(c) {
	case 'l': /* region size */
	    len = atoi(optarg);
	    break;
	case 'o': /* offset */
	    off = atoi(optarg);
	    break;
	case 'f':
	    fname = optarg;
	    break;
	case 'w':
	    allow_write = 1;
	    prot |= PROT_WRITE;
	    break;
	case 'p':
	    private = 1;
	    break;
	case 't':
	    if(optarg[0] == 'w') touch_region = 2;
	    else touch_region = 1;
	    break;
	}
    }
    if(len == -1) 
	errx(1,"usage: mmap -l len [-f file] [-o offset] [-t r|w] [-wp]");
    printf("my pid = %d\n", getpid());
    if(fname) {
	fd = open(fname, allow_write ? O_RDWR : O_RDONLY);
	if(fd == -1)
	    warn("open");
    }
    flags = (private ? MAP_PRIVATE : MAP_SHARED);
    if(fd == -1) flags |= MAP_ANON;
    printf("ready to mmaping memory, press <Return>\n");
    getchar();
    addr = mmap(NULL, len, prot, flags, fd, off);
    if(addr == MAP_FAILED) 
	err(1,"mmap");
    printf("%d bytes at offset %qd from fd %d mmaped. Press <Return>\n", 
	   len, off, fd);
    getchar();
    if(touch_region) {
	switch (touch_region) {
	case 1:
	    memcmp(addr, addr, len);
	    break;
	case 2:
	    bzero(addr, len);
	    break;
	}
	printf("mmaped region %s. Press <Return>\n", 
	       touch_region == 2 ? "zeroed" : "touched");
	getchar();
    }
    munmap(addr, len);
    close(fd);

    return 0;
}
